// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "Collider2D.hpp"

namespace Dawn {
  class TriggerController2D : public SceneItemComponent {
    public:
      Collider2D *collider = nullptr;

      StateEvent<CharacterController2D*> eventTriggerEnter;

      TriggerController2D(SceneItem *i);
      std::vector<SceneItemComponent*> getDependencies() override;

      /**
       * Returns whether or not the given moving object is colliding with this
       * trigger collider.
       */
      bool_t getCollidingResult(Collider2D* movingObject)
  };
}